#define	COM_PIN	    RC2
#define COM_TX	    COM_PIN    
#define	COM_PORT    PORTC    
    
WAIT_COM:				; wait 1/9600 sec = 104us
    MOVLW	.26
    MOVWF	tmp0
COM_WAIT_1:
    DECFSZ	tmp0,F
    GOTO	COM_WAIT_1
    RETLW	0
    
print_data:
    MOVLW	STX			;start of text
    MOVWF	COM_BUF
    CALL	send_byte
    
    MOVF	TLSB,W
    MOVWF	COM_BUF
    CALL	send_byte   
    
    MOVF	TMSB,W
    MOVWF	COM_BUF
    CALL	send_byte
    
    MOVF	fsregt,W
    MOVWF	COM_BUF
    CALL	send_byte

    MOVF	temp,W
    MOVWF	COM_BUF
    CALL	send_byte
    
    MOVF	temp_real,W
    MOVWF	COM_BUF
    CALL	send_byte

    MOVF	main_state,W
    MOVWF	COM_BUF
    CALL	send_byte

    MOVLW	ETX
    MOVWF	COM_BUF
    CALL	send_byte
    
    GOTO	print_data_ret

send_byte:
    BCF		COM_PORT,COM_TX
    CALL	WAIT_COM
    MOVLW	.8
    MOVWF	COM_PTR
    GOTO	$+1
    GOTO	$+1
COM_LOOP_1:
    NOP
    BTFSS	COM_BUF,0
    GOTO	COM_LOOP_2
    BSF		COM_PORT,COM_TX
    GOTO	COM_LOOP_3
COM_LOOP_2:
    BCF		COM_PORT,COM_TX
    NOP
COM_LOOP_3:
    CALL	WAIT_COM
    RRF		COM_BUF,F
    DECFSZ	COM_PTR,F
    GOTO	COM_LOOP_1
COM_LOOP_END:
    BSF		COM_PORT,COM_TX		;send stop byte
    CALL	WAIT_COM
    DelayUs	2550
    RETLW	0